## gpsd 3.20

=== SConstruct ===
# SCons build recipe for the GPSD project

# Important targets:
#
# build      - build the software (default)
# dist       - make distribution tarball (requires GNU tar)
# install    - install programs, libraries, and manual pages
# uninstall  - undo an install
#
# check      - run regression and unit tests.
# audit      - run code-auditing tools
# testbuild  - test-build the code from a tarball
# website    - refresh the website
# release    - ship a release
#
# --clean    - clean all normal build targets
#
# Setting the DESTDIR environment variable will prefix the install destinations
# without changing the --prefix prefix.

# Unfinished items:
# * Out-of-directory builds: see http://www.scons.org/wiki/UsingBuildDir
# * Coveraging mode: gcc "-coverage" flag requires a hack
#   for building the python bindings
# * Python 3 compatibility in this recipe

# Since SCons 3.0.0 forces print_function on us, it needs to be unconditional.
# This is recognized to be a bug in SCons, but we need to live with it for now,
# and we'll need this for eventual Python 3 compatibility, anyway.
# Python requires this to precede any non-comment code.
from __future__ import print_function

import ast
import functools
import glob
import imp         # for imp.find_module('gps'), imp deprecated in 3.4
import operator
import os
import pickle
import re
# replacement for functions from the commands module, which is deprecated.
import subprocess
import sys
import time
from distutils import sysconfig
import SCons


# Release identification begins here.
#
# Actual releases follow the normal X.Y or X.Y.Z scheme.  The version
# number in git between releases has the form X.Y~dev, when it is
# expected that X.Y will be the next actual release.  As an example,
# when 3.20 is the last release, and 3.20.1 is the expected next
# release, the version in git will be 3.20.1~dev.  Note that ~ is used,
# because there is some precedent, ~ is an allowed version number in
# the Debian version rules, and it does not cause confusion with
# whether - separates components of the package name, separates the
# name from the version, or separates version componnents.
#
# Keep in sync with gps/__init__.py
# There are about 16 files with copies of the version number; make
# sure to update all of them.
#
# package version
gpsd_version = "3.20"
# client library version
libgps_version_current = 25
libgps_version_revision = 0
libgps_version_age = 0
libgps_version = "%d.%d.%d" % (libgps_version_current, libgps_version_age,
                               libgps_version_revision)
#
# Release identification ends here

# Hosting information (mainly used for templating web pages) begins here
# Each variable foo has a corresponding @FOO@ expanded in .in files.
# There are no project-dependent URLs or references to the hosting site
# anywhere else in the distribution; preserve this property!
annmail = "gpsd-announce@nongnu.org"
bugtracker = "https://gitlab.com/gpsd/gpsd/issues"
cgiupload = "root@thyrsus.com:/var/www/cgi-bin/"
clonerepo = "git@gitlab.com:gpsd/gpsd.git"
devmail = "gpsd-dev@lists.nongnu.org"
download = "http://download-mirror.savannah.gnu.org/releases/gpsd/"
formserver = "www@thyrsus.com"
gitrepo = "git@gitlab.com:gpsd/gpsd.git"
ircchan = "irc://chat.freenode.net/#gpsd"
mailman = "https://lists.nongnu.org/mailman/listinfo/"
mainpage = "https://gpsd.io"
projectpage = "https://gitlab.com/gpsd/gpsd"
scpupload = "garyemiller@dl.sv.nongnu.org:/releases/gpsd/"
sitename = "GPSD"
sitesearch = "gpsd.io"
tiplink = "<a href='https://www.patreon.com/esr'>" \
          "leave a remittance at Patreon</a>"
tipwidget = '<p><a href="https://www.patreon.com/esr">' \
            'Donate here to support continuing development.</a></p>'
usermail = "gpsd-users@lists.nongnu.org"
webform = "http://www.thyrsus.com/cgi-bin/gps_report.cgi"
website = "https://gpsd.io/"
# Hosting information ends here

# gpsd needs Scons version at least 2.3
EnsureSConsVersion(2, 3, 0)
# gpsd needs Python version at least 2.6
EnsurePythonVersion(2, 6)


PYTHON_SYSCONFIG_IMPORT = 'from distutils import sysconfig'

# Utility productions


def Utility(target, source, action, **kwargs):
    target = env.Command(target=target, source=source, action=action, **kwargs)
    env.AlwaysBuild(target)
    env.Precious(target)
    return target


def UtilityWithHerald(herald, target, source, action, **kwargs):
    if not env.GetOption('silent'):
        action = ['@echo "%s"' % herald] + action
    return Utility(target=target, source=source, action=action, **kwargs)


def _getstatusoutput(cmd, nput=None, shell=True, cwd=None, env=None):
    pipe = subprocess.Popen(cmd, shell=shell, cwd=cwd, env=env,
                            stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    (output, errout) = pipe.communicate(input=nput)
    status = pipe.returncode
    return (status, output)


def _getoutput(cmd, nput=None, shell=True, cwd=None, env=None):
    return _getstatusoutput(cmd, nput, shell, cwd, env)[1]


# Spawn replacement that suppresses non-error stderr
def filtered_spawn(sh, escape, cmd, args, env):
    proc = subprocess.Popen([sh, '-c', ' '.join(args)],
                            env=env, close_fds=True, stderr=subprocess.PIPE)
    _, stderr = proc.communicate()
    if proc.returncode:
        sys.stderr.write(stderr)
    return proc.returncode

#
# Build-control options
#


# without this, scons will not rebuild an existing target when the
# source changes.
Decider('timestamp-match')

# support building with various Python versions.
sconsign_file = '.sconsign.{}.dblite'.format(pickle.HIGHEST_PROTOCOL)
SConsignFile(sconsign_file)

# Start by reading configuration variables from the cache
opts = Variables('.scons-option-cache')

systemd_dir = '/lib/systemd/system'
systemd = os.path.exists(systemd_dir)

# Set distribution-specific defaults here
imloads = True

boolopts = (
    # GPS protocols
    ("ashtech",       True,  "Ashtech support"),
    ("earthmate",     True,  "DeLorme EarthMate Zodiac support"),
    ("evermore",      True,  "EverMore binary support"),
    ("fury",          True,  "Jackson Labs Fury and Firefly support"),
    ("fv18",          True,  "San Jose Navigation FV-18 support"),
    ("garmin",        True,  "Garmin kernel driver support"),
    ("garmintxt",     True,  "Garmin Simple Text support"),
    ("geostar",       True,  "Geostar Protocol support"),
    ("greis",         True,  "Javad GREIS support"),
    ("itrax",         True,  "iTrax hardware support"),
    ("mtk3301",       True,  "MTK-3301 support"),
    ("navcom",        True,  "Navcom NCT support"),
    ("nmea0183",      True,  "NMEA0183 support"),
    ("nmea2000",      True,  "NMEA2000/CAN support"),
    ("oncore",        True,  "Motorola OnCore chipset support"),
    ("sirf",          True,  "SiRF chipset support"),
    ("skytraq",       True,  "Skytraq chipset support"),
    ("superstar2",    True,  "Novatel SuperStarII chipset support"),
    ("tnt",           True,  "True North Technologies support"),
    ("tripmate",      True,  "DeLorme TripMate support"),
    ("tsip",          True,  "Trimble TSIP support"),
    ("ublox",         True,  "u-blox Protocol support"),
    # Non-GPS protocols
    ("aivdm",         True,  "AIVDM support"),
    ("gpsclock",      True,  "GPSClock support"),
    ("isync",         True,  "Spectratime iSync LNRClok/GRCLOK support"),
    ("ntrip",         True,  "NTRIP support"),
    ("oceanserver",   True,  "OceanServer support"),
    ("passthrough",   True,  "build support for passing through JSON"),
    ("rtcm104v2",     True,  "rtcm104v2 support"),
    ("rtcm104v3",     True,  "rtcm104v3 support"),
    # Time service
    ("oscillator",    True,  "Disciplined oscillator support"),
    # Export methods
    ("dbus_export",   True,  "enable DBUS export support"),
    ("shm_export",    True,  "export via shared memory"),
    ("socket_export", True,  "data export over sockets"),
    # Communication
    ("bluez",         True,  "BlueZ support for Bluetooth devices"),
    ("netfeed",       True,  "build support for handling TCP/IP data sources"),
    ('usb',           True,  "libusb support for USB devices"),
    # Other daemon options
    ("control_socket", True,  "control socket for hotplug notifications"),
    ("force_global",  False, "force daemon to listen on all addressses"),
    ("systemd",       systemd, "systemd socket activation"),
    # Client-side options
    ("clientdebug",   True,  "client debugging support"),
    ("libgpsmm",      True,  "build C++ bindings"),
    ("ncurses",       True,  "build with ncurses"),
    ("qt",            True,  "build Qt bindings"),
    # Daemon options
    ("controlsend",   True,  "allow gpsctl/gpsmon to change device settings"),
    ("reconfigure",   True,  "allow gpsd to change device settings"),
    ("squelch",       False, "squelch gpsd_log/gpsd_hexdump to save cpu"),
    # Build control
    ("coveraging",    False, "build with code coveraging enabled"),
    ("debug",         False, "include debug information in build"),
    ("gpsdclients",   True,  "gspd client programs"),
    ("gpsd",          True,  "gpsd itself"),
    ("implicit_link", imloads, "implicit linkage is supported in shared libs"),
    ("magic_hat", sys.platform.startswith('linux'),
     "special Linux PPS hack for Raspberry Pi et al"),
    ("manbuild",      True,  "build help in man and HTML formats"),
    ("minimal", False, "turn off every option not set on the command line"),
    ("nostrip",       False, "don't symbol-strip binaries at link time"),
    ("profiling",     False, "build with profiling enabled"),
    ("python",        True,  "build Python support and modules."),
    ("shared",        True,  "build shared libraries, not static"),
    ("timeservice",   False, "time-service configuration"),
    ("xgps",          True,  "include xgps and xgpsspeed."),
    # Test control
    ("slow",          False, "run tests with realistic (slow) delays"),
)

# now step on the boolopts just read from '.scons-option-cache'
for (name, default, helpd) in boolopts:
    opts.Add(BoolVariable(name, helpd, default))

# Gentoo, Fedora, opensuse systems use uucp for ttyS* and ttyUSB*
if os.path.exists("/etc/gentoo-release"):
    def_group = "uucp"
else:
    def_group = "dialout"

nonboolopts = (
    ("gpsd_group",       def_group,     "privilege revocation group"),
    ("gpsd_user",        "nobody",      "privilege revocation user",),
    ("max_clients",      '64',          "maximum allowed clients"),
    ("max_devices",      '4',           "maximum allowed devices"),
    ("prefix",           "/usr/local",  "installation directory prefix"),
    ("python_coverage",  "coverage run", "coverage command for Python progs"),
    ("python_libdir",    "",            "Python module directory prefix"),
    ("qt_versioned",     "",            "version for versioned Qt"),
    ("sysroot",          "",            "cross-development system root"),
    ("target",           "",            "cross-development target"),
    ("target_python",    "python",      "target Python version as command"),
)

# now step on the non boolopts just read from '.scons-option-cache'
for (name, default, helpd) in nonboolopts:
    opts.Add(name, helpd, default)

pathopts = (
    ("bindir",              "bin",           "application binaries directory"),
    ("docdir",              "share/doc",     "documents directory"),
    ("includedir",          "include",       "header file directory"),
    ("libdir",              "lib",           "system libraries"),
    ("mandir",              "share/man",     "manual pages directory"),
    ("pkgconfig",           "$libdir/pkgconfig", "pkgconfig file directory"),
    ("sbindir",             "sbin",          "system binaries directory"),
    ("sysconfdir",          "etc",           "system configuration directory"),
    ("udevdir",             "/lib/udev",     "udev rules directory"),
)

# now step on the path options just read from '.scons-option-cache'

=== contrib/SConstruct ===
# This is a skeleton recipe to simplify building some of these little
# utilities. They probably won't be useful to many users, and they probably
# won't get used on a daily basis, but someone might find them useful for
# tinkering with their gear.

# Note that ../gpsd_config.h is required and is built separately
#
# This file is Copyright (c) 2010-2018 by the GPSD project
# SPDX-License-Identifier: BSD-2-clause


ashctl = Program("ashctl", "ashctl.c")
binlog = Program("binlog", "binlog.c")
binreplay = Program("binreplay", "binreplay.c", parse_flags=['-lutil'])
clock_test = Program("clock_test", "clock_test.c", parse_flags=['-lm'])
lla2ecef = Program("lla2ecef", "lla2ecef.c", parse_flags=['-lm'])
motosend = Program("motosend", "motosend.c")

Default(ashctl, binlog, binreplay, clock_test, lla2ecef, motosend)

=== debian/changelog ===
gpsd (3.20-4) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * [58b18a53] apparmor: fix control socket usage for gpsdctrl (LP: #1790496)
    The subsequent access of the daemon to the device is covered already.
      # common serial paths to GPS devices
      /dev/tty{,S,USB,AMA,ACM}[0-9]*    rw,
    But gpsdctl itself isn't yet - therefore we see
      $ sudo gpsdctl add /dev/ttyUSB0
    triggering:
      apparmor="DENIED profile="/usr/sbin/gpsd" name="/run/gpsd.sock" requested_mask="r" denied_mask="r"
    This change adds a rule for that.
    Signed-off-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 01 Feb 2020 01:11:24 +0100

gpsd (3.20-3) unstable; urgency=medium

  * Uploading to unstable.

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 12 Jan 2020 20:16:47 +0100

gpsd (3.20-2) experimental; urgency=medium

  * [4f1c9d4f] Merge branch 'non-linux' into 'master'
    Build fixes for non-Linux archs
    See merge request debian-gps-team/pkg-gpsd!2
  * [7196c903] Updating debian/control from debian/control.in
  * [2227686a] Redo changes accidentally done in d/control
  * [f3a7fb54] Add patch to fix soname.
    Went missing upstream somewhere
  * [49d89d24] Update gbp.conf for experimental

 -- Bernd Zeimetz <bzed@debian.org>  Wed, 08 Jan 2020 23:21:55 +0100

gpsd (3.20-1) unstable; urgency=medium

  * [9edad156] It is /dev/ttyACM[0-9]+, not /dev/ACM[0-9]+.
    Fix the apparmor profile. (Closes: #944521)
  * [13daa71f] Update upstream source from tag 'upstream/3.20'
    Update to upstream version '3.20'
    with Debian dir d2e29602486466a54dcd800a73e727aa3ef129ce
  * [51f56687] Refreshing patches.
  * [55d0b5b4] Updating changelog
  * [fd2a44f4] Fix gpsd.docs for asciidoc.
    Files were converted by upstream
  * [2da3f0f4] python-gps is gone, remove .install file also
  * [9759c33a] python3-gps.install: update for new file/module names.
  * [10f81da8] gpsd-dbg.install: update debug binaries
  * [f529940a] Updating symbols files
  * [5c851b49] Ignore the build-time test for xgps deps.
    We'll deliver them as dependency, no worries.
  * [32358c88] Use python_libdir instead of a mv hack.
  * [bf7651e1] Install soelim stubs instead of links for manpages.
    Seems to work fine, so why keep the extra work?
  * [7ee82f94] Remove chrpath hack. Not needed anymore it seems.
  * [55d2d180] Depend on asciidoc.
  * [c8f81b96] Don't install non-build-related python deps.
  * [aa045a15] libQgpsmm.3 is not yet compressed at install time
  * [cfa6a5d3] Fix shebang in the debug scripts
  * [53178b81] Updating changelog
  * [9133a8a2] Limit the shebang fix to python files only

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 04 Jan 2020 02:34:41 +0100

gpsd (3.19-3) unstable; urgency=medium

  * [ba252b48] Use one sconsign file per pickle version.
    Thanks to Graham Inggs (Closes: #945238)

 -- Bernd Zeimetz <bzed@debian.org>  Thu, 21 Nov 2019 19:51:42 +0100

gpsd (3.19-2) unstable; urgency=medium

  * [06ae5582] Add debian/.gitlab-ci.yml
  * [b200620e] Update Vcs-Git Urls
  * [1991f99e] git is not available on buildds.
  * [809c6c4a] Remove weird env flag overrides
  * [85c4fbb7] snapshot changelog
  * [24e0be41] try again
  * [ede12b7b] Merge branch 'master' of salsa.debian.org:debian-gps-team/pkg-gpsd
  * [29fe8717] Remove options only used by the init script.
  * [0232f523] Scons ignores hardening-flags and others, try this.
  * [d163bdcd] Revert "Scons ignores hardening-flags and others, try this."
    This reverts commit 0232f52302f65f545118f653f787daf2429d0c0a.
  * [27d27ef5] A better try to fix scons env handling
  * [fc43714a] More fixes for the env-handling.
  * [9b34a869] Fix the broken fix
  * [6fd99707] Also merge CFLAGS/CXXFLAGS/...
  * [200cf80c] Also try to fix python cflags handling
  * [0dd50707] Use python3 for default scons things.
    After building the first version with python 3, the pickle version of
    the cached scons data will be too old.
  * [bbf652ee] Remove python2 support.
    Building both python versions got impossible since recent python3
    versions use a new picke version and scons stores its state in a pickle
    file...
  * [8eee1d20] Also remove dependencies on python-gps
  * [e3b30066] Updating debian/control from debian/control.in
  * [0332c8e5] Remove duplicate build-deps
  * [62b43a57] Updating changelog
  * [a8bbbce5] Use python3 for gpsd-clients
  * [288e9075] gpsd-clients breaks/replaces python-gps
  * [2f21db33] use aptly
  * [fd092a4d] Use python3-gi instead of python3-gtk
  * [0be9eebd] changes need to go into control.in
  * [a620b1d5] Depend on python3
  * [cbf832dd] Updating debian/control from debian/control.in

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 13 Oct 2019 21:56:20 +0200

=== debian/control ===
Source: gpsd
Section: misc
Priority: optional
Maintainer: Bernd Zeimetz <bzed@debian.org>
Build-Depends: debhelper (>= 11),
 po-debconf,
 python3-all-dev (>= 2.6.6-3),
 python3-all-dbg (>= 2.6.6-3),
 python3-all-dev,
 xsltproc, docbook-xsl, docbook-xml,
 libncurses-dev,
 libusb-1.0-0-dev,
 libdbus-1-dev, libglib2.0-dev, libdbus-glib-1-dev, makedev,
 libbluetooth-dev [linux-any],
 qtbase5-dev,
 lsb-release, bc,
 dpkg-dev (>= 1.15.6),
 scons (>= 3.0.1-2~),
 dh-buildinfo,
 dh-python,
 dh-apparmor,
 dh-exec,
 pps-tools (>= 0.20120406+g0deb9c7e-2~) [linux-any],
 pkg-config,
 asciidoc
Standards-Version: 4.2.1
Homepage: http://www.catb.org/gpsd/
Vcs-Browser: https://github.com/bzed/pkg-gpsd
Vcs-Git: https://github.com/bzed/pkg-gpsd.git
X-Python3-Version: >= 3.5

Package: gpsd
Architecture: any
Depends: netbase | systemd-sysv, lsb-base (>= 3.2-13),
 adduser (>= 3.34),
 ${shlibs:Depends}, ${misc:Depends},
 libgps26 (= ${binary:Version})
Recommends: udev [linux-any], ${python:Depends}, python
Breaks: ${gpsd:Breaks}
Suggests: gpsd-clients, dbus, apparmor
Conflicts: fso-gpsd
Multi-Arch: foreign
Description: Global Positioning System - daemon
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 With gpsd, multiple GPS client applications can share access to devices
 without contention or loss of data. Also, gpsd responds to queries with a
 format that is substantially easier to parse than the different standards
 emitted by GPS devices.

Package: gpsd-dbg
Architecture: any
Section: debug
Suggests: gpsd-dbgsym
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
 libgps26 (= ${binary:Version}) | gpsd (= ${binary:Version}) | gpsd-clients (= ${binary:Version}) | python3-gps (= ${binary:Version})
Description: Global Positioning System - debugging symbols
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains the python debug modules and some test tools
 to the debug the behaviour of gpsd. Debug symbols are being shipped
 in the dbgsym package.

Package: gpsd-clients
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libgps26 (= ${binary:Version}),
 python3-gps, python3-gi, python3-cairo, gir1.2-gtk-3.0, python3-serial, python3-gi-cairo, ${python3:Depends},
 python3
Suggests: gpsd
Breaks: python-gps
Replaces: python-gps
Description: Global Positioning System - clients
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains auxiliary tools and example clients for monitoring,
 testing, latency-profiling, device configuration and simulating gpsd.

Package: python3-gps
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Recommends: gpsd
Provides: ${python:Provides}
Breaks: ${python:Breaks}
Description: Global Positioning System - Python 3 libraries
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains a Python 3 interface to connect to gpsd, together with
 a module providing a controlled testing environment.

Package: libgps26
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gpsd
Conflicts: fso-gpsd
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Global Positioning System - library
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libgps, a C service library for querying GPS
 devices. It supports both a low-level interface, which communicates
 directly with the device to which the GPS is connected, and a high-level
 interface, which goes through gpsd and is intended for concurrent use by
 several applications.

Package: libgps-dev
Architecture: any
Section: libdevel
Depends: libgps26 (= ${binary:Version}), ${misc:Depends}, pkg-config
Description: Global Positioning System - development files
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package contains the header and development files needed to build
 programs and packages using libgps.

Package: libqgpsmm26
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Global Positioning System - Qt wrapper for libgps
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides libQgpsmm, the Qt version of libgpsmm.
 It is a wrapper over libgps, the service library for querying GPS
 devices. libQgpsmm is available on all platforms which are supported
 by Qt4.

Package: libqgpsmm-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, pkg-config,
 libqgpsmm26 (= ${binary:Version}),
 libgps-dev (= ${binary:Version})
Description: Global Positioning System - Qt wrapper for libgps (development)
 The gpsd service daemon can monitor one or more GPS devices connected to
 a host computer, making all data on the location and movements of the
 sensors available to be queried on TCP port 2947.
 .
 This package provides the development file for libQgpsmm, the Qt version of
 libgpsmm. It contains pkgconfig and qmake bits to build with the library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

#uncomment if debhelper should be verbose
#export DH_VERBOSE=1

LIBGPS_SONAME := $(strip $(shell grep -E '^libgps_version_current' SConstruct | sed 's,.*=[^0-9]*\([0-9]*\).*,\1,'))

export QT_SELECT=qt5

LIBGPS_DEBIAN_FILE_SOURCES := $(strip $(shell ls -1 debian/*LIBGPSSONAME* ))
LIBGPS_DEBIAN_FILE_TARGETS := $(strip $(shell echo $(LIBGPS_DEBIAN_FILE_SOURCES) | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g'))

#python versions
PYTHONS := $(shell py3versions -r)
PYTHON3 := $(shell py3versions -d)

#debhelper version and settings needed for udev
DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')
LSB_RELEASE := $(shell lsb_release -si)
UDEV_BREAKS =

ifeq (Debian,$(strip $(LSB_RELEASE))) ## debian ##
ifeq (0, $(strip $(shell dpkg --compare-versions $(DH_VERSION) ge 7.3.15; echo $$?)))
UDEV_BREAKS = 125
endif
else ## not debian ##
ifeq (Ubuntu,$(strip $(LSB_RELEASE))) ## ubuntu ##
ifeq (0, $(strip $(shell dpkg --compare-versions $(DH_VERSION) ge 7.0.17ubuntu2; echo $$?)))
UDEV_BREAKS = 136-1
endif
endif ## ubuntu ##
endif ## debian ##


DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

SCONSOPTS = \
	prefix=/usr \
	systemd=yes \
	nostrip=yes \
	dbus_export=yes \
	docdir=/usr/share/doc/gpsd \
	libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	gpsd_user=gpsd \
	gpsd_group=dialout \
	qt_versioned=5 \
	python_libdir=/usr/lib/python3/dist-packages

ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += manbuild=no
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	SCONSOPTS += debug=yes
else
	SCONSOPTS += debug=no
endif

#package names
PACKAGE_GPSD := gpsd
PACKAGE_CLIENTS := gpsd-clients
PACKAGE_LIB := libgps$(LIB_soname)
PACKAGE_QTLIB := libqgpsmm$(LIB_soname)
PACKAGE_LIB_DEV := libgps-dev
PACKAGE_QTLIB_DEV := libqgpsmm-dev
PACKAGE_PY := python-gps
PACKAGE_PY3 := python3-gps
PACKAGE_GPSDDBG := gpsd-dbg


cflags := $(shell dpkg-buildflags --get CFLAGS)
cppflags := $(shell dpkg-buildflags --get CPPFLAGS)
cxxflags := $(shell dpkg-buildflags --get CXXFLAGS)
ldflags := $(shell dpkg-buildflags --get LDFLAGS)

SCONS_ENV := set -e ;\
		export LDFLAGS="$(ldflags)" ;\
		export CFLAGS="$(cflags)" ;\
		export CXXFLAGS="$(cxxflags)" ;\
		export CPPFLAGS="$(cppflags)";


$(LIBGPS_DEBIAN_FILE_TARGETS): $(LIBGPS_DEBIAN_FILE_SOURCES)
	for source in $(LIBGPS_DEBIAN_FILE_SOURCES); do \
	    target=$$(echo "$$source" | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g') ;\
	    sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' "$$source" > "$$target" ;\
	done

debian/control: debian/control.in
		rm -f $@
		sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g' $< > $@
		if which git 1>/dev/null && [ -d .git ]; then \
			git add debian/control ;\
			git commit -m 'Updating debian/control from debian/control.in' debian/control ;\
		fi ;\

SConstruct.deb_revision: SConstruct
	if [ ! -f $@ ]; then \
		cp $< $@ ;\
		sed -i '/^revision=/s/%(.*)/%("$(DEB_VERSION)",)/' $< ;\
	fi
	touch $@

build-indep: build
build-arch: build

build: build-stamp build-static-stamp
build-stamp: SConstruct.deb_revision
	set -e; \
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) $${py} /usr/bin/scons $(SCONSOPTS) target_python=$${py} ; \
	    done
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	# disable tests on hurd due to weird ipv6 errors
	# http://deb.li/4C46AEAC.7040906@bzed.de
ifeq (,$(findstring hurd,$(DEB_HOST_ARCH_OS)))
	-$(SCONS_ENV) $(PYTHON3) /usr/bin/scons check
endif
endif
	# ensure the test tools are built
	$(SCONS_ENV) $(PYTHON3) /usr/bin/scons $(SCONSOPTS) $(shell grep test_ debian/gpsd-dbg.install | grep -v '\.py' | awk '{print $$1}')
	touch $@

build-static-stamp: SConstruct.deb_revision
	cp libgps_static.a libgps.a
	touch $@

clean: debian/control
	dh_testdir
	dh_testroot
	set -e; \
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) $${py} /usr/bin/scons $(SCONSOPTS) target_python=$${py} --clean ; \
	    done
	$(SCONS_ENV) $(PYTHON3) /usr/bin/scons $(SCONSOPTS) sconsclean || true
	# revert revision changes in SConstruct
	if [ -f SConstruct.deb_revision ]; then \
	    mv SConstruct.deb_revision SConstruct; \
	fi
	rm -rf \
	    .sconf_temp \
	    .scons-option-cache \
	    .sconsign.dblite \
	    .sconsign.*.dblite \
	    gps/*.pyc \
	    TROUBLESHOOTING \
	    debian/buildinfo.gz \
	    config.log \
	    debian/shlibs.local \
	    leapsecond.pyc \
	    libgps.a \
	    $(LIBGPS_DEBIAN_FILE_TARGETS) \
	    __pycache__
	dh_clean

install: install-stamp
install-stamp: build-stamp build-static-stamp $(LIBGPS_DEBIAN_FILE_TARGETS)
	dh_testdir
	dh_testroot
	dh_prep
	set -e ;\
	    for py in $(PYTHONS); do \
	    	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp $${py} /usr/bin/scons install $(SCONSOPTS) target_python=$${py} ;\
	    done
	# install static lib
	cp libgps.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	cp INSTALL.adoc TROUBLESHOOTING.adoc
	# install systemd files
	mkdir -p debian/tmp/lib/systemd/system
	cp systemd/* debian/tmp/lib/systemd/system
	# install everything
	dh_install
	# quirk to avoid issues by broken fakeroot misdetecting links as files and
	# then breaking dh_install -> cp -a fatally
	ln -s libgps.so.$(LIBGPS_SONAME).0.0 debian/libgps$(LIBGPS_SONAME)/usr/lib/$(DEB_HOST_MULTIARCH)/libgps.so.$(LIBGPS_SONAME)
	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgps.so.$(LIBGPS_SONAME)
	dh_missing --fail-missing
	# use python3
	sed -i 's,/usr/bin/env python,/usr/bin/env python3,' debian/gpsd-clients/usr/bin/*
	sed -i 's,^#!python.*,#!/usr/bin/python3,' debian/*/usr/lib/gpsd/debug/*.py
	touch $@


install-indep: install
install-arch: install

binary: install-stamp
	dh_testdir
	dh_testroot
	dh_installchangelogs  NEWS
	dh_installdocs
	dh_installman
	dh_installmenu
	dh_apparmor --profile-name=usr.sbin.gpsd -pgpsd
	dh_installsystemd -pgpsd --restart-after-upgrade gpsdctl@.service gpsd.socket
	dh_installsystemd -pgpsd --no-enable --no-start gpsd.service
	dh_installinit --no-start
	dh_installsystemd -pgpsd --restart-after-upgrade
	dh_installexamples
	chmod 755 debian/$(PACKAGE_PY3)/usr/lib/python3*/*-packages/gps/gps.py
	dh_python3 -Ngpsd -Ngpsd-clients -Ngpsd-dbg
	dh_python3 -pgpsd-dbg usr/lib/gpsd/debug
	dh_python3 -pgpsd-clients usr/bin
	dh_python3 -pgpsd lib/udev/
	cp $(CURDIR)/gpsd.rules $(CURDIR)/debian/gpsd.udev
	dh_installudev
	dh_link
	dh_strip --dbgsym-migration='gpsd-dbg (<< 3.16-4~)'
	dh_buildinfo -p$(PACKAGE_GPSDDBG)
	dh_compress
	dh_fixperms  -Xgpsd.hotplug
	dh_lintian
ifeq (,$(DEB_BUILD_OPTIONS))
	dh_makeshlibs -Nlibqgpsmm$(LIBGPS_SONAME) -- -c4
	dh_makeshlibs -plibqgpsmm$(LIBGPS_SONAME) -- -c1
else
	dh_makeshlibs
endif
	dh_shlibdeps
ifneq (,$(UDEV_BREAKS))
	echo "gpsd:Breaks=udev (<< $(UDEV_BREAKS))" >> $(CURDIR)/debian/gpsd.substvars
endif
	dh_gencontrol
	dh_installdeb
	dh_md5sums
	dh_builddeb


binary-indep: binary
binary-arch: binary

.PHONY: binary binary-indep binary-arch \
	install install-arch install-indep \
	clean \
	build debian/control

## gpsd 3.22

=== SConstruct ===
""" SCons build recipe for the GPSD project

Important targets:

build      - build the software (default)
dist       - make distribution tarballs .gz and .xz, plus .zip
zip        - make distribution zip
install    - install programs, libraries, and manual pages
uninstall  - undo an install

check      - run regression and unit tests.
audit      - run code-auditing tools
testbuild  - test-build the code from a tarball
website    - refresh the website
release    - ship a release

--clean    - clean all normal build targets
-c         - clean all normal build targets

Useful options:
--warn=all - to see scons warnings

Setting the DESTDIR environment variable will prefix the install destinations
without changing the --prefix prefix.

Pretty much all this file does is create the variant_dir, and call SConscript.
"""

# Unfinished items:
# * Coveraging mode: gcc "-coverage" flag requires a hack
#   for building the python bindings

# This file is Copyright 2010 by the GPSD project
# SPDX-License-Identifier: BSD-2-clause
#
# This code runs compatibly under Python 2 and 3.x for x >= 2.
# Preserve this property!
from __future__ import print_function

import atexit      # for atexit.register()
import os

# gpsd needs Scons version at least 2.3
EnsureSConsVersion(2, 3, 0)
# gpsd needs Python version at least 2.6
EnsurePythonVersion(2, 6)

# package version
gpsd_version = "3.22"
# name 'build' is already taken, put stuff in gpsd-$VERSION
# it makes tar simple
variantdir = 'gpsd-' + gpsd_version

# one touch clean!
# also, for brutal effect, you can do: git clean -dfx
if GetOption('clean'):
    # .pages and .public are GitLab "pages".
    clean_targets = '%s buildtmp .public .pages testbuild' % variantdir
    atexit.register(lambda: os.system('rm -rf ' + clean_targets))

# Not everything respects this  chdir()
SConscriptChdir(1)
SConscript('SConscript',
           duplicate=1,
           exports=['gpsd_version', 'variantdir'],
           must_exit=True,
           variant_dir=variantdir,
           )
# VariantDir('buildtmp', '.')
# SConscript('buildtmp/SConscript', must_exit=True, duplicate=1)

=== doc/Makefile ===
explanation.html: $(shell ls *.xml)
	xmlto xhtml-nochunks internals.xml

=== debian/changelog ===
gpsd (3.22-4) unstable; urgency=high

  * [2df40c76] Fix: GPSD time will jump back 1024 weeks at after week=2180
    (Closes: #991739)
  * [c6af361a] Fix patch

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 01 Aug 2021 21:58:54 +0200

gpsd (3.22-3) unstable; urgency=medium

  * [c6838e37] Remove duplicate lines from symbol files.
    Thanks to Matthias Klose (Closes: #985930)
  * [5c240253] Mark String::QString(QString const&)@Base as optional.
    Required for backporting.
  * [2dfbaa07] Updating debian/control from debian/control.in
  * [c582b2aa] gpsd-tools: add missing Breaks+Replaces
    gpsd-tools needs Breaks/Replaces for gpsd-clients (<< 3.20-10)
    Thanks to Andreas Beckmann (Closes: #987208)

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 25 Apr 2021 12:17:57 +0200

gpsd (3.22-2) unstable; urgency=medium

  [ Bernd Zeimetz ]
  * [66691096] Update Apparmor profile from upstream git HEAD.
    Thanks to Christian Ehrhardt (Closes: #976152) (LP: #1894330)

  [ Christian Ehrhardt ]
  * [63f0cbf0] symbols: nanowait came back as (int, timespec*)
    Signed-off-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>

 -- Bernd Zeimetz <bzed@debian.org>  Wed, 13 Jan 2021 19:20:14 +0100

gpsd (3.22-1) unstable; urgency=medium

  [ Pino Toscano ]
  * [d78fef17] Limit libsystemd-dev & libudev-dev build-deps as linux-any

  [ Bernd Zeimetz ]
  * [5afe80fe] New upstream version 3.22
  * [d23d0669] Updating debian/control from debian/control.in
  * [fde91987] libgps-dev: mark as M-A: same.
    Thanks to Lisandro Damián Nicanor Pérez Meyer (Closes: #912580)

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 09 Jan 2021 22:42:25 +0100

gpsd (3.21.99~rc1-2) unstable; urgency=medium

  * Uploading to unstable
  * [ac4c2cbe] add automatically generated rdep builder
  * [3420d64b] Revert "Updating gbp.conf for experimental"
    This reverts commit c524723236f6334db4605752172412707e7f2cb3.

 -- Bernd Zeimetz <bzed@debian.org>  Wed, 06 Jan 2021 01:36:36 +0100

gpsd (3.21.99~rc1-1) experimental; urgency=medium


  * [7936993f] Fixing git URLs
  * [3296cd58] removing extra linebreak
  * [8faaf157] Updating debian/control from debian/control.in
  * [c5247232] Updating gbp.conf for experimental
  * [4e2f5ac1] New upstream version 3.21.1~dev
  * [e01b4392] refreshing patches
  * [82d5b474] Addint matplotlib as dependency
  * [b905b4a6] snapshot changelog
  * [d415ffbd] remove gpsd build dir
  * [2a2d7e26] move dh_clean in order
  * [792171ef] Remove debian/source/options
  * [45c11a24] also remove buildtmp symlink
  * [b72ada42] add asciidoctor as build-dep
  * [704c85c4] Updating debian/control from debian/control.in
  * [8fa23322] remove gpsd-dbg package
  * [bf066735] Updating debian/control from debian/control.in
  * [18cf7d90] things happen in Sconscript, not sconstruct
  * [13d41b86] copy files from build dir
  * [448b12a0] Really ignore xgps deps check
  * [6b612ecf] add all the python stuff as build-dep
    tools are executed at build time
  * [61c389fe] Updating debian/control from debian/control.in
  * [04d323b3] python modules are pure python now
    no need to build for each python release
  * [c428275b] Build static library first, then the shared version
  * [a60bae70] add libsystemd-dev as build-dep
  * [5d5b5749] Updating debian/control from debian/control.in
  * [0ef4040b] add libudev-dev as build-dep
  * [3c09ab29] Updating debian/control from debian/control.in
  * [4cc239f6] tidy build-dir after static build
  * [a3991765] Fix filename of static library
  * [943cdb1e] No python c modules anymore
  * [7a0a4c1a] more fixes for SConstruct -> SConscript migration
  * [cf9802b0] scons fails to check xsltproc.
    force it
  * [520d0fb6] Don't call scons for clean.
    Just remove the builddir.
  * [3d6ad4ee] Remove upstream installed documentation
  * [01a55541] Install new gpsd-client tools.
  * [8ea6798e] install libgpsdpacket into python3-gps
  * [24703969] no python debug build anymore
  * [525cd475] Fix typo
  * [cf8b732e] install systemd service files
  * [1a5ac994] Update gpsd-clients.examples
  * [6ac6556e] install examples with dh_install
    dh_installexamples doesn't support #!/usr/bin/dh-exec....
  * [8bcc5152] Fix udev source location
  * [b317fad6] Updating symbols file
  * [90e3c370] Updating libgps symbols file.
    Also sorting it.
  * [112fdad9] Use scons systemd_install
  * [c2de2379] Add missing "" for c++ symbols
  * [88af2338] fix symbols
  * [5d4c7e4f] mark one more symbol as missing
  * [1814e3c1] New upstream version 3.21.99~rc1
  * [58d93d7d] Remove patch that is not needed anymore
  * [92242a31] snapshot changelog
  * [155be863] Updating debian/control from debian/control.in
  * [f2668dc0] try to build reverse-dep automatically
  * [44310e1a] gitlab ci fixes
  * [74f7bf91] actually enable job
  * [84eed5c3] assume yes for apt
  * [d557db05] remove old X-Python settings
  * [19770775] fix python3 shebangs
  * [dde6ae6a] add some more -y for apt
  * [f142e929] remove python2 shebang replacements

 -- Bernd Zeimetz <bzed@debian.org>  Mon, 04 Jan 2021 17:05:16 +0100

gpsd (3.20-12) unstable; urgency=medium

  [ Bernd Zeimetz ]
  * [b7a30c42] Disable reprotest on CI for now.
    Until somebody comes up with a fix.

  [ Christian Ehrhardt ]
  * [fccbcc8f] fix json missing quotes on device add (LP: #1879272)
    Signed-off-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>

 -- Bernd Zeimetz <bzed@debian.org>  Wed, 20 May 2020 09:04:54 +0200

gpsd (3.20-11) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * [232c8d73] d/rules: fix ubxtool to use python3 in the gpsd package (LP: #1878158)
    Signed-off-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>

 -- Bernd Zeimetz <bzed@debian.org>  Tue, 12 May 2020 13:49:15 +0200

gpsd (3.20-10) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * [7670b61e] exchange gpsd-client/tools content
  * [fb81a96a] examples also need to be in -clients instead of -tools then


=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 #uncomment if debhelper should be verbose
 #export DH_VERBOSE=1
 
-LIBGPS_SONAME := $(strip $(shell grep -E '^libgps_version_current' SConstruct | sed 's,.*=[^0-9]*\([0-9]*\).*,\1,'))
+LIBGPS_SONAME := $(strip $(shell grep -E '^libgps_version_current' SConscript | sed 's,.*=[^0-9]*\([0-9]*\).*,\1,'))
 
 export QT_SELECT=qt5
 
@@ -13,8 +13,8 @@
 LIBGPS_DEBIAN_FILE_TARGETS := $(strip $(shell echo $(LIBGPS_DEBIAN_FILE_SOURCES) | sed 's,LIBGPSSONAME,$(LIBGPS_SONAME),g'))
 
 #python versions
-PYTHONS := $(shell py3versions -r)
-PYTHON3 := $(shell py3versions -d)
+#PYTHON3 := $(shell py3versions -d)
+PYTHON3 := python3
 
 #debhelper version and settings needed for udev
 DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')
@@ -50,6 +50,8 @@
 
 ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
 	SCONSOPTS += manbuild=no
+else
+	SCONSOPTS += manbuild=yes
 endif
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
@@ -61,13 +63,13 @@
 #package names
 PACKAGE_GPSD := gpsd
 PACKAGE_CLIENTS := gpsd-clients
+PACKAGE_TOOLS := gpsd-tools
 PACKAGE_LIB := libgps$(LIB_soname)
 PACKAGE_QTLIB := libqgpsmm$(LIB_soname)
 PACKAGE_LIB_DEV := libgps-dev
 PACKAGE_QTLIB_DEV := libqgpsmm-dev
 PACKAGE_PY := python-gps
 PACKAGE_PY3 := python3-gps
-PACKAGE_GPSDDBG := gpsd-dbg
 
 
 cflags := $(shell dpkg-buildflags --get CFLAGS)
@@ -96,7 +98,7 @@
 			git commit -m 'Updating debian/control from debian/control.in' debian/control ;\
 		fi ;\
 
-SConstruct.deb_revision: SConstruct
+SConscript.deb_revision: SConscript
 	if [ ! -f $@ ]; then \
 		cp $< $@ ;\
 		sed -i '/^revision=/s/%(.*)/%("$(DEB_VERSION)",)/' $< ;\
@@ -106,40 +108,47 @@
 build-indep: build
 build-arch: build
 
-build: build-stamp build-static-stamp
-build-stamp: SConstruct.deb_revision
-	set -e; \
-	    for py in $(PYTHONS); do \
-	    	$(SCONS_ENV) $${py} /usr/bin/scons $(SCONSOPTS) target_python=$${py} ; \
-	    done
+build: build-stamp
+build-stamp: SConscript.deb_revision build-static-stamp
+	$(SCONS_ENV) $(PYTHON3) /usr/bin/scons shared=yes $(SCONSOPTS) target_python=$(PYTHON3)
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
 	# disable tests on hurd due to weird ipv6 errors
 	# http://deb.li/4C46AEAC.7040906@bzed.de
 ifeq (,$(findstring hurd,$(DEB_HOST_ARCH_OS)))
+
+	# remove those binary tests we can't patch with quilt.
+	rm -f test/daemon/garmin18x-bin.log
+	rm -f test/daemon/sirfstarv.log
+	rm -f test/daemon/trimble-lasseniq-bin2d.log
+	rm -f test/daemon/ublox-ned-m8t-sbfrx3.log
+	rm -f test/daemon/ublox-neo-m8t-s.log
+	rm -f test/daemon/ublox-neo-m8t.log
+	rm -f test/daemon/ublox-zed-f9p-hp.log
+	rm -f test/daemon/ublox-zed-f9p_hpg1.11.log
+	rm -f test/daemon/ublox-zed-f9t-rtcm3.log
+
 	-$(SCONS_ENV) $(PYTHON3) /usr/bin/scons check
 endif
 endif
-	# ensure the test tools are built
-	$(SCONS_ENV) $(PYTHON3) /usr/bin/scons $(SCONSOPTS) $(shell grep test_ debian/gpsd-dbg.install | grep -v '\.py' | awk '{print $$1}')
-	touch $@
-
-build-static-stamp: SConstruct.deb_revision
-	cp libgps_static.a libgps.a
+	touch $@
+
+build-static-stamp: SConscript.deb_revision
+	$(SCONS_ENV) $(PYTHON3) /usr/bin/scons shared=no $(SCONSOPTS) target_python=$(PYTHON3)
+	cp gpsd-*/libgps.a libgps.a
+	rm -rf gpsd-*
 	touch $@
 
 clean: debian/control
 	dh_testdir
 	dh_testroot
-	set -e; \
-	    for py in $(PYTHONS); do \
-	    	$(SCONS_ENV) $${py} /usr/bin/scons $(SCONSOPTS) target_python=$${py} --clean ; \
-	    done
-	$(SCONS_ENV) $(PYTHON3) /usr/bin/scons $(SCONSOPTS) sconsclean || true
-	# revert revision changes in SConstruct
-	if [ -f SConstruct.deb_revision ]; then \
-	    mv SConstruct.deb_revision SConstruct; \
+	# revert revision changes in SConscript
+	if [ -f SConscript.deb_revision ]; then \
+	    mv SConscript.deb_revision SConscript; \
 	fi
+	dh_clean
 	rm -rf \
+		buildtmp \
+		gpsd-* \
 	    .sconf_temp \
 	    .scons-option-cache \
 	    .sconsign.dblite \
@@ -153,23 +162,18 @@
 	    libgps.a \
 	    $(LIBGPS_DEBIAN_FILE_TARGETS) \
 	    __pycache__
-	dh_clean
-
-install: install-stamp
+: install-stamp
 install-stamp: build-stamp build-static-stamp $(LIBGPS_DEBIAN_FILE_TARGETS)
 	dh_testdir
 	dh_testroot
 	dh_prep
-	set -e ;\
-	    for py in $(PYTHONS); do \
-	    	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp $${py} /usr/bin/scons install $(SCONSOPTS) target_python=$${py} ;\
-	    done
+	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp $(PYTHON3) /usr/bin/scons install $(SCONSOPTS) target_python=$(PYTHON3)
+	$(SCONS_ENV) DESTDIR=`pwd`/debian/tmp $(PYTHON3) /usr/bin/scons systemd_install $(SCONSOPTS) target_python=$(PYTHON3)
 	# install static lib
 	cp libgps.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
 	cp INSTALL.adoc TROUBLESHOOTING.adoc
-	# install systemd files
-	mkdir -p debian/tmp/lib/systemd/system
-	cp systemd/* debian/tmp/lib/systemd/system
+	# we collect our own documentation
+	rm -rf debian/tmp/usr/share/doc/gpsd
 	# install everything
 	dh_install
 	# quirk to avoid issues by broken fakeroot misdetecting links as files and
@@ -177,13 +181,8 @@
 	ln -s libgps.so.$(LIBGPS_SONAME).0.0 debian/libgps$(LIBGPS_SONAME)/usr/lib/$(DEB_HOST_MULTIARCH)/libgps.so.$(LIBGPS_SONAME)
 	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgps.so.$(LIBGPS_SONAME)
 	dh_missing --fail-missing
-	# use python3
-	sed -i 's,/usr/bin/env python,/usr/bin/env python3,' debian/gpsd-clients/usr/bin/*
-	sed -i 's,^#!python.*,#!/usr/bin/python3,' debian/*/usr/lib/gpsd/debug/*.py
-	touch $@
-
-
-install-indep: install
+	touch $@
+: install
 install-arch: install
 
 binary: install-stamp
@@ -198,17 +197,14 @@
 	dh_installsystemd -pgpsd --no-enable --no-start gpsd.service
 	dh_installinit --no-start
 	dh_installsystemd -pgpsd --restart-after-upgrade
-	dh_installexamples
 	chmod 755 debian/$(PACKAGE_PY3)/usr/lib/python3*/*-packages/gps/gps.py
-	dh_python3 -Ngpsd -Ngpsd-clients -Ngpsd-dbg
-	dh_python3 -pgpsd-dbg usr/lib/gpsd/debug
+	dh_python3 -Ngpsd-clients
 	dh_python3 -pgpsd-clients usr/bin
 	dh_python3 -pgpsd lib/udev/
-	cp $(CURDIR)/gpsd.rules $(CURDIR)/debian/gpsd.udev
+	cp $(CURDIR)/gpsd-*/gpsd.rules $(CURDIR)/debian/gpsd.udev
 	dh_installudev
 	dh_link
 	dh_strip --dbgsym-migration='gpsd-dbg (<< 3.16-4~)'
-	dh_buildinfo -p$(PACKAGE_GPSDDBG)
 	dh_compress
 	dh_fixperms  -Xgpsd.hotplug
 	dh_lintian

=== debian/tests/control ===
Tests: check-service
Depends: gpsd, systemd, grep, coreutils, telnet
Restrictions: needs-root, isolation-container
